public class Sudoku {
    static int[][] sudoku; // the sudoku field, accessible in every method

    /// return true iff there is a solution to solve the sudoku puzzle
    public static boolean solve() {
        /**********************************/
        // INSERT YOUR CODE HERE
        /**********************************/
    }

    /// helper method for a recursive solution
    public static boolean solveRec(int x, int y) {
        /**********************************/
        // INSERT YOUR CODE HERE
        /**********************************/
    }

    public static void main(String[] args) {
        String path = FileUtils.getFilePath();
        sudoku = pua.FileUtils.readIntMatrix(path);
        checkFieldSize();

        display(); // print sudoku field before calling solve()
        boolean has_solution = solve(); // solve() should modify the sudoku field so a valid solution
                                        // will be printed here
        if(has_solution == true) {
            System.out.println("Sudoku has a solution!");
            display();
        } else {
            System.out.println("Sudoku has no solution!");
        }
    }

    // Some helper methods are defined below. You do not need to modify anything
    // below this line!

    /// check if the sudoku has size 9x9
    public static void checkFieldSize() {
        if (sudoku.length != 9) {
            throw new RuntimeException("Sudoku field has invalid height!");
        }
        for (int y = 0; y < 9; y++) {
            if (sudoku[y].length != 9) {
                throw new RuntimeException("Sudoku field has invalid width!");
            }
        }
    }

    /// check if field (x, y) is empty
    public static boolean isEmpty(int x, int y) {
        return sudoku[y][x] == 0;
    }

    /// write number val into field (x, y)
    public static void writeNumber(int x, int y, int val) {
        if (val <= 0 || val > 9) {
            throw new RuntimeException("Use setField only with values between 1 and 9!");
        }
        sudoku[y][x] = val;
    }

    /// set field (x, y) empty
    public static void clearNumber(int x, int y) {
        sudoku[y][x] = 0;
    }

    /// check if placing val at (x, y) violates sudoku rules
    public static boolean checkValidNumber(int x, int y, int val) {
        if (val <= 0 || val > 9) {
            throw new RuntimeException("Use checkValidNumber only with values between 1 and 9!");
        }

        // check column
        for (int y_i = 0; y_i < 9; y_i++) {
            if (y == y_i) {
                continue;
            }
            if (sudoku[y_i][x] == val) {
                return false;
            }
        }

        // check row
        for (int x_i = 0; x_i < 9; x_i++) {
            if (x == x_i) {
                continue;
            }
            if (sudoku[y][x_i] == val) {
                return false;
            }
        }

        // check square
        int x_start = (x / 3) * 3;
        int y_start = (y / 3) * 3;
        for (int x_i = x_start; x_i < x_start + 3; x_i++) {
            for (int y_i = y_start; y_i < y_start + 3; y_i++) {
                if (x_i == x && y_i == y) {
                    continue;
                }
                if (sudoku[y_i][x_i] == val) {
                    return false;
                }
            }
        }

        return true;
    }

    // Some strings used to display the sudoku field
    final static String U_LEFT = "\u250F\u2501";
    final static String U_MID_V_NORMAL = "\u2501\u2501\u252F\u2501";
    final static String U_MID_V_HEAVY = "\u2501\u2501\u2533\u2501";
    final static String U_RIGHT = "\u2501\u2501\u2513";
    final static String CH_LEFT = "\u2523\u2501";
    final static String CH_MID_V_NORMAL = "\u2501\u2501\u253F\u2501";
    final static String CH_MID_V_HEAVY = "\u2501\u2501\u254B\u2501";
    final static String CH_RIGHT = "\u2501\u2501\u252B";
    final static String CN_LEFT = "\u2520\u254C";
    final static String CN_MID_V_NORMAL = "\u254C\u254C\u253C\u254C";
    final static String CN_MID_V_HEAVY = "\u254C\u254C\u2542\u254C";
    final static String CN_RIGHT = "\u254C\u254C\u2528";
    final static String L_LEFT = "\u2517\u2501";
    final static String L_MID_V_NORMAL = "\u2501\u2501\u2537\u2501";
    final static String L_MID_V_HEAVY = "\u2501\u2501\u253B\u2501";
    final static String L_RIGHT = "\u2501\u2501\u251B";
    final static String H_HEAVY = "\u2503";
    final static String H_NORMAL = "\u254E";

    public static void display() {
        // upper row
        System.out.print(U_LEFT);
        for (int i = 0; i < 8; i++) {
            System.out.print(i % 3 == 2 ? U_MID_V_HEAVY : U_MID_V_NORMAL);
        }
        System.out.println(U_RIGHT);
        for (int i = 0; i < 9; i++) {
            // row with numbers
            for (int j = 0; j < 9; j++) {
                System.out.print(j % 3 == 0 ? H_HEAVY : H_NORMAL);
                System.out.print(sudoku[i][j] == 0 ? "   " : " " + sudoku[i][j] + " ");
            }
            System.out.println(H_HEAVY);
            // row between numbers
            if (i == 8) {
                break;
            } else if (i % 3 == 2) {
                System.out.print(CH_LEFT);
                for (int j = 0; j < 8; j++) {
                    System.out.print(j % 3 == 2 ? CH_MID_V_HEAVY : CH_MID_V_NORMAL);
                }
                System.out.println(CH_RIGHT);
            } else {
                System.out.print(CN_LEFT);
                for (int j = 0; j < 8; j++) {
                    System.out.print(j % 3 == 2 ? CN_MID_V_HEAVY : CN_MID_V_NORMAL);
                }
                System.out.println(CN_RIGHT);
            }
        }
        // lower row
        System.out.print(L_LEFT);
        for (int i = 0; i < 8; i++) {
            System.out.print(i % 3 == 2 ? L_MID_V_HEAVY : L_MID_V_NORMAL);
        }
        System.out.println(L_RIGHT);
    }
}
